=== debian/changelog ===
lsp-plugins (1.1.10-0ubuntu1) eoan; urgency=medium

  * New upstream version 1.1.10
  * Removed unnecessary patches

 -- Erich Eickmeyer <erich@ericheickmeyer.com>  Mon, 22 Jul 2019 17:25:02 -0700

lsp-plugins (1.1.9-0ubuntu2) eoan; urgency=medium

  * Disabled test build
  * Cleanup rules file to allow multiple architectures

 -- Erich Eickmeyer <erich@ericheickmeyer.com>  Tue, 04 Jun 2019 12:54:49 -0700

lsp-plugins (1.1.9-0ubuntu1) eoan; urgency=medium

  * Initial Release for Ubuntu (LP: #1827288)
  * Bump Standards and Debhelper
  * Split plugin types to separate packages
  * Add upstream metadata

 -- Erich Eickmeyer <erich@ericheickmeyer.com>  Wed, 01 May 2019 15:02:15 -0700
