## lsp-plugins 1.1.11

=== debian/changelog ===
lsp-plugins (1.1.11-0ubuntu1) focal; urgency=medium

  * New upstream version 1.1.11

 -- Erich Eickmeyer <erich@ericheickmeyer.com>  Sat, 21 Dec 2019 12:48:34 -0800
