## lsp-plugins 1.1.13

=== Makefile ===
--- 
+++ 
@@ -120,6 +120,7 @@
 testdebug: export BUILD_MODULES   = jack
 testdebug: test_compile
 
+testprofile: OBJDIR                 = $(TESTDIR)
 testprofile: export CFLAGS         += -g -pg -O2 -DLSP_PROFILING -DLSP_TESTING -DLSP_TRACE -g3 -no-pie -fno-pie -fPIC
 testprofile: export CXXFLAGS       += -g -pg -O2 -DLSP_PROFILING -DLSP_TESTING -DLSP_TRACE -g3 -no-pie -fno-pie -fPIC
 testprofile: export EXE_TEST_FLAGS += -g -pg -O2 -g3 -no-pie -fno-pie -fPIC
@@ -282,4 +283,3 @@
 release_jack: release_prepare
 	@echo "Releasing JACK binaries"
 	@mkdir -p $(RELEASE_BIN)/$(JACK_ID)-$(BUILD_SYSTEM)-$(BUILD_PROFILE)
-	@mkdir -p $(RELEASE_BIN)/$(JACK_ID)-$(BUILD_SYSTEM)-$(BUILD_PROFILE)/lib/$(ARTIFACT_ID)
