=== src/dsp/Makefile ===
--- 
+++ 
@@ -18,8 +18,8 @@
 SSE2_INSTR_SET          = -mmmx -m3dnow -msse -msse2
 SSE3_INSTR_SET          = $(SSE_INSTR_SET) -msse3 -mssse3
 SSE4_INSTR_SET          = $(SSE_INSTR_SET) -msse4.1 -msse4.2
-AVX_INSTR_SET           = -mavx
-AVX2_INSTR_SET          = -mavx -mavx2
+AVX_INSTR_SET           = -mavx -mvzeroupper
+AVX2_INSTR_SET          = $(AVX_INSTR_SET) -mavx2
 NEON_D32_INSTR_SET      = -mfpu=neon-vfpv4
 ASIMD_INSTR_SET      	= -march=armv8-a+simd
 
@@ -39,6 +39,12 @@
   endif
 endif
 ifeq ($(BUILD_PROFILE), armv7a)
+LINK_OBJECTS           += $(ARM_IMPL) $(NEON_D32_IMPL)
+endif
+ifeq ($(BUILD_PROFILE), armv7ve)
+LINK_OBJECTS           += $(ARM_IMPL) $(NEON_D32_IMPL)
+endif
+ifeq ($(BUILD_PROFILE), arm32)
 LINK_OBJECTS           += $(ARM_IMPL) $(NEON_D32_IMPL)
 endif
 ifeq ($(BUILD_PROFILE), aarch64)
