=== src/utils/Makefile ===
--- 
+++ 
@@ -68,6 +68,6 @@
 	
 $(UTL_RESGEN): $(FILES) $(SUBDIRS)
 	@echo "  $(CXX) $(notdir $(UTL_RESGEN))"
-	@$(CXX) -o $(UTL_RESGEN) $(OBJDIR)/resource_gen.o $(OBJ_FILES) $(OBJ_DSP) $(OBJ_EXTRA) $(EXPAT_HEADERS) $(EXE_FLAGS) $(EXPAT_LIBS) $(SNDFILE_LIBS) $(DL_LIBS) $(OBJ_LIBS)
+	@$(CXX) -o $(UTL_RESGEN) $(OBJDIR)/resource_gen.o $(OBJ_FILES) $(OBJ_DSP) $(OBJ_EXTRA) $(EXE_FLAGS) $(SNDFILE_LIBS) $(DL_LIBS) $(OBJ_LIBS)
