=== debian/changelog ===
lsp-plugins (1.1.13-0ubuntu2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:19:20 +0100

lsp-plugins (1.1.13-0ubuntu1) focal; urgency=medium

  * New upstream version 1.1.13 (hotfix)

 -- Erich Eickmeyer <erich@ericheickmeyer.com>  Mon, 23 Dec 2019 22:25:13 -0800
