=== debian/rules ===
--- 
+++ 
@@ -25,3 +25,11 @@
 override_dh_auto_test:
 	# the test suite requires build options incompatible with what we
 	# ship in the package, so disable until upstream resolves this
+
+override_dh_install:
+	# Documentation contains privacy-invading IFRAMEs in HTML code
+	# which generates Lintian warnings. HTML documentation is
+	# therefore removed, and documentation is linked at 
+	# https://lsp-plug.in/?page=manuals
+	rm -r debian/tmp/usr/share/doc/lsp-plugins
+	dh_install
