=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/lsp-plugins-src-?(\d\S*)\.tar\.gz/lsp-plugins-$1\.tar\.gz/ \
 https://github.com/sadko4u/lsp-plugins/releases .*/lsp-plugins-src-(\d\S*)\.tar\.gz
